searchData={"content_type":"text/markdown","items":[{"doc":"This is the documentation for the Desktop project.\n\nBy default, Desktop applications depend on the following packages:\n\n  * [Phoenix](https://hexdocs.pm/phoenix) - the Phoenix web framework\n\n  * [Phoenix LiveView](https://hexdocs.pm/phoenix_live_view) - real-time\n    user experience\n\n  * [Sqlite3 Ecto](https://github.com/elixir-sqlite/ecto_sqlite3) - local\n    database\n\nTo get started, see the [Getting Started Guide](./guides/getting_started.md).\n\nThis library is still worked on heaviliy and APIs are going to change in v2. If you are curious\nto play around or contribute it's to best clone the current sample app at:\nhttps://github.com/elixir-desktop/desktop-example-app and start modifying it to your wishes.","ref":"Desktop.html","title":"Desktop","type":"module"},{"doc":"Call on application to use the system locale by default for\n  translations. The function will scan your gettext backend for available\n  languages and compare to the system language to select the best match.\n\n  ```\n    Desktop.identify_default_locale(MyApp.Gettext)\n  ```","ref":"Desktop.html#identify_default_locale/1","title":"Desktop.identify_default_locale/1","type":"function"},{"doc":"","ref":"Desktop.html#language_code/0","title":"Desktop.language_code/0","type":"function"},{"doc":"","ref":"Desktop.html#live_view_version/0","title":"Desktop.live_view_version/0","type":"function"},{"doc":"Allows setting the default locale that will be used for translations in this\n  Desktop application.","ref":"Desktop.html#put_default_locale/1","title":"Desktop.put_default_locale/1","type":"function"},{"doc":"Auth provider that ensures that only the wanted WebView can open an interact\n  with the application. A token is generated and compared to ensure no other application\n  can connect to the local webserver.","ref":"Desktop.Auth.html","title":"Desktop.Auth","type":"module"},{"doc":"","ref":"Desktop.Auth.html#call/2","title":"Desktop.Auth.call/2","type":"function"},{"doc":"","ref":"Desktop.Auth.html#init/1","title":"Desktop.Auth.init/1","type":"function"},{"doc":"","ref":"Desktop.Auth.html#login_key/0","title":"Desktop.Auth.login_key/0","type":"function"},{"doc":"","ref":"Desktop.Endpoint.html","title":"Desktop.Endpoint","type":"module"},{"doc":"Env holds any needed :wx / Desktop application state. Currently\nit keeps track of\n* The open Desktop.Window(s),\n* OS Application events (such as when a file is dragged on the application icon)\n* The :wx environment\n* The dbus connection (sni) on linux\n\nAlso it has a global connect() method to allow binding of :wx event callbacks using\nthis long lived process as reference.","ref":"Desktop.Env.html","title":"Desktop.Env","type":"module"},{"doc":"Returns the currently used webview backend","ref":"Desktop.Env.html#backend/0","title":"Desktop.Env.backend/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Desktop.Env.html#child_spec/1","title":"Desktop.Env.child_spec/1","type":"function"},{"doc":"Returns the raw ExSni handle if used under linux to talk to DBus.","ref":"Desktop.Env.html#sni/0","title":"Desktop.Env.sni/0","type":"function"},{"doc":"Wrapper around wx.subscribe()\n\n  Will send to the calling process events in the form:\n\n  * `{:print_file, [filename]}`\n  * `{:open_file, [filename]}`\n  * `{:open_url, [filename]}`\n  * `{:new_file, []}`","ref":"Desktop.Env.html#subscribe/0","title":"Desktop.Env.subscribe/0","type":"function"},{"doc":"Returns the wx object. This is what has been created by the application using `:wx.new/1`. You\ntypically need a reference to this to execute raw `:wx` commands.","ref":"Desktop.Env.html#wx/0","title":"Desktop.Env.wx/0","type":"function"},{"doc":"Gets the Desktop process's current raw `:wx` environment.\nCan be sent to other processes to allow them use this process wx environment.","ref":"Desktop.Env.html#wx_env/0","title":"Desktop.Env.wx_env/0","type":"function"},{"doc":"iex> :wx.set_env(Desktop.Env.wx_env())\n    iex> :wxWebView.isContextMenuEnabled(Desktop.Window.webview(pid))\n    false","ref":"Desktop.Env.html#wx_env/0-example","title":"Example - Desktop.Env.wx_env/0","type":"function"},{"doc":"Shortcut for `:wx.set_env(Desktop.Env.wx_env())`","ref":"Desktop.Env.html#wx_use_env/0","title":"Desktop.Env.wx_use_env/0","type":"function"},{"doc":"Fallback handles version differences in the :wx modules needed for showing the\n  WebView and Desktop notifications and it uses the highest available\n  feature level while trying to stays backwards compatible to older :wx versions.","ref":"Desktop.Fallback.html","title":"Desktop.Fallback","type":"module"},{"doc":"","ref":"Desktop.Fallback.html#notification_new/2","title":"Desktop.Fallback.notification_new/2","type":"function"},{"doc":"","ref":"Desktop.Fallback.html#notification_show/4","title":"Desktop.Fallback.notification_show/4","type":"function"},{"doc":"","ref":"Desktop.Fallback.html#webview_backend_env/0","title":"Desktop.Fallback.webview_backend_env/0","type":"function"},{"doc":"","ref":"Desktop.Fallback.html#webview_can_fix/1","title":"Desktop.Fallback.webview_can_fix/1","type":"function"},{"doc":"","ref":"Desktop.Fallback.html#webview_new/1","title":"Desktop.Fallback.webview_new/1","type":"function"},{"doc":"","ref":"Desktop.Fallback.html#webview_rebuild/1","title":"Desktop.Fallback.webview_rebuild/1","type":"function"},{"doc":"","ref":"Desktop.Fallback.html#webview_show/3","title":"Desktop.Fallback.webview_show/3","type":"function"},{"doc":"","ref":"Desktop.Fallback.html#webview_url/1","title":"Desktop.Fallback.webview_url/1","type":"function"},{"doc":"","ref":"Desktop.Fallback.html#wx_get_env/0","title":"Desktop.Fallback.wx_get_env/0","type":"function"},{"doc":"","ref":"Desktop.Fallback.html#wx_new/1","title":"Desktop.Fallback.wx_new/1","type":"function"},{"doc":"","ref":"Desktop.Fallback.html#wx_subscribe/0","title":"Desktop.Fallback.wx_subscribe/0","type":"function"},{"doc":"Menu module used to create and handle menus in Desktop\n\nMenus are defined similar to Live View using a callback module an XML:\n\n```\n  defmodule ExampleMenuBar do\n    use Desktop.Menu\n\n    @impl true\n    def mount(menu) do\n      menu = assign(menu, items: ExampleRepo.all_items())\n      {:ok, menu}\n    end\n\n    @impl true\n    def handle_event(command, menu) do\n      case command do\n        <<\"open\">> -> :not_implemented\n        <<\"quit\">> -> Desktop.Window.quit()\n        <<\"help\">> -> Desktop.OS.launch_default_browser('https://google.com')\n        <<\"about\">> -> :not_implemented\n      end\n\n      {:noreply, menu}\n    end\n\n    @impl true\n    def render(assigns) do\n      ~E\"\"\"\n       \n         \">\n             <%= gettext \"Open\" %> \n             \n             <%= gettext \"Quit\" %> \n         \n         \">\n          <%= for item <- @items do %>\n             <%= item.name %> \n          <% end %>\n         \n         \">\n             <%= gettext \"Show Documentation\" %> \n             <%= gettext \"About\" %> \n         \n       \n      \"\"\"\n    end\n  end\n```\n\n# Template\n\nAs in live view the template can either be embedded in the `def render(assigns)`\nmethod or it can be side loaded as a .eex file next to the menus .ex file.\n\n# XML Structure\n\nThese items are defined:\n\n## ` ...menus... `\n\nFor an application (window) menubar this must be the root element. When\npassing a menubar to `Desktop.Window` start parameters this has to be the root element.\nIt has no attributes\n\n## ` ...items... `\n\nFor an icon menu `menu` must be the root element. Menu elements can contain multiple\nchildren of type `menu`, `item` and `hr`\n\n#","ref":"Desktop.Menu.html","title":"Desktop.Menu","type":"behaviour"},{"doc":"* `label` - the label that should be displayed on the menu\n\n## ` Label `\n\nThis is an entry in the menu with a text a type and an onclick action\n\n#","ref":"Desktop.Menu.html#module-attributes","title":"Attributes - Desktop.Menu","type":"behaviour"},{"doc":"* `onclick` - an event name that should be fired when this item is clicked. It will cause `handle_event/2` to be called\n* `type`        - the type of the item. The default is `normal`, but it can be either\n  * `normal`    - a normal text item\n  * `radio`     - a radio button\n  * `checkbox`  - a checkbox item\n* `checked` - whether the `checkbox` or `radio` button should be checked. `nil`, `false` and `0` are treated\nas false values, every other value is treated as true.\n* `disabled` - whether the item should be disabled. `nil`, `false` and `0` are treated\nas false values, every other value is treated as true.\n\n## ` `\n\nA separator item","ref":"Desktop.Menu.html#module-attributes","title":"Attributes - Desktop.Menu","type":"behaviour"},{"doc":"","ref":"Desktop.Menu.html#assign/2","title":"Desktop.Menu.assign/2","type":"function"},{"doc":"","ref":"Desktop.Menu.html#assign/3","title":"Desktop.Menu.assign/3","type":"function"},{"doc":"","ref":"Desktop.Menu.html#assign_new/3","title":"Desktop.Menu.assign_new/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Desktop.Menu.html#child_spec/1","title":"Desktop.Menu.child_spec/1","type":"function"},{"doc":"","ref":"Desktop.Menu.html#connected?/1","title":"Desktop.Menu.connected?/1","type":"function"},{"doc":"","ref":"Desktop.Menu.html#get_icon/1","title":"Desktop.Menu.get_icon/1","type":"function"},{"doc":"","ref":"Desktop.Menu.html#c:handle_event/2","title":"Desktop.Menu.handle_event/2","type":"callback"},{"doc":"","ref":"Desktop.Menu.html#c:handle_info/2","title":"Desktop.Menu.handle_info/2","type":"callback"},{"doc":"","ref":"Desktop.Menu.html#menubar/1","title":"Desktop.Menu.menubar/1","type":"function"},{"doc":"","ref":"Desktop.Menu.html#c:mount/1","title":"Desktop.Menu.mount/1","type":"callback"},{"doc":"","ref":"Desktop.Menu.html#popup_menu/1","title":"Desktop.Menu.popup_menu/1","type":"function"},{"doc":"","ref":"Desktop.Menu.html#c:render/1","title":"Desktop.Menu.render/1","type":"callback"},{"doc":"","ref":"Desktop.Menu.html#set_icon/2","title":"Desktop.Menu.set_icon/2","type":"function"},{"doc":"","ref":"Desktop.Menu.html#start!/2","title":"Desktop.Menu.start!/2","type":"function"},{"doc":"","ref":"Desktop.Menu.html#start_link/2","title":"Desktop.Menu.start_link/2","type":"function"},{"doc":"","ref":"Desktop.Menu.html#trigger_event/2","title":"Desktop.Menu.trigger_event/2","type":"function"},{"doc":"","ref":"Desktop.Menu.html#t:t/0","title":"Desktop.Menu.t/0","type":"type"},{"doc":"The OS module provides shortcuts and helper functions\n  to access OS specific information.\n\n  Most significant one should use OS.type() to differentiate\n  between the currently supported environments:\n  - Android\n  - IOS\n  - MacOS\n  - Windows\n  - Linux","ref":"Desktop.OS.html","title":"Desktop.OS","type":"module"},{"doc":"Returns the users home directory","ref":"Desktop.OS.html#home/0","title":"Desktop.OS.home/0","type":"function"},{"doc":"","ref":"Desktop.OS.html#kill_process/1","title":"Desktop.OS.kill_process/1","type":"function"},{"doc":"Replacement for the :wx_misc.launchDefaultBrowser function","ref":"Desktop.OS.html#launch_default_browser/1","title":"Desktop.OS.launch_default_browser/1","type":"function"},{"doc":"","ref":"Desktop.OS.html#mobile?/0","title":"Desktop.OS.mobile?/0","type":"function"},{"doc":"This is a Path.expand variant that normalizes the drive letter\non windows","ref":"Desktop.OS.html#path_expand/1","title":"Desktop.OS.path_expand/1","type":"function"},{"doc":"","ref":"Desktop.OS.html#restart/0","title":"Desktop.OS.restart/0","type":"function"},{"doc":"","ref":"Desktop.OS.html#shutdown/0","title":"Desktop.OS.shutdown/0","type":"function"},{"doc":"","ref":"Desktop.OS.html#type/0","title":"Desktop.OS.type/0","type":"function"},{"doc":"","ref":"Desktop.OS.html#windows?/0","title":"Desktop.OS.windows?/0","type":"function"},{"doc":"Defines a Desktop Window.\n\nThe window hosts a Phoenix Endpoint and displays its content.\nIt should be part of a supervision tree and is the main interface\nto interact with your application.\n\nIn total the window is doing:\n\n  * Displaying the endpoint content\n\n  * Hosting and starting an optional menu bar\n\n  * Controlling a taskbar icon if present","ref":"Desktop.Window.html","title":"Desktop.Window","type":"module"},{"doc":"You can add the Window to your own Supervision tree:\n\n    children = [{\n      Desktop.Window,\n      [\n        app: :your_app,\n        id: YourAppWindow,\n        title: \"Your App Title\",\n        size: {600, 500},\n        icon: \"icon.png\",\n        menubar: YourApp.MenuBar,\n        icon_menu: YourApp.Menu,\n        url: fn -> YourAppWeb.Router.Helpers.live_url(YourAppWeb.Endpoint, YourAppWeb.YourAppLive) end\n      ]\n    }]\n\n\n#","ref":"Desktop.Window.html#module-the-window","title":"The Window - Desktop.Window","type":"module"},{"doc":"In order to change the appearance of the application window these options can be defined:\n\n  * `:app` - your app name within which the Window is running.\n\n  * `:id` - an atom identifying the window. Can later be used to control the\n    window using the functions of this module.\n\n  * `:title` - the window title that will be show initially. The window\n    title can be set later using `set_title/2`.\n\n  * `:size` - the initial windows size in pixels {width, height}.\n\n  * `:min_size` - the minimum windows size in pixels {width, height}.\n\n  * `:hidden` - whether the window should be initially hidden defaults to false,\n                but is ignored on mobile platforms\n\n      Possible values are:\n\n      * `false` - Show the window on startup (default)\n      * `true` - Don't show the window on startup\n\n  * `:icon` - an icon file name that will be used as window and\n    taskbar icon (unless another `:taskbar_icon` is specified).\n    Supported formats are png files\n\n  * `:taskbar_icon` - an icon file name that will be used as taskbar icon.\n    Supported formats are png files\n\n  * `:menubar` - an optional MenuBar module that will be rendered\n    as the windows menu bar when given.\n\n  * `:icon_menu` - an optional MenuBar module that will be rendered\n    as menu onclick on the taskbar icon.\n\n  * `:url` - a callback to the initial (default) url to show in the\n    window.","ref":"Desktop.Window.html#module-window-configuration","title":"Window configuration - Desktop.Window","type":"module"},{"doc":"","ref":"Desktop.Window.html#close_window/2","title":"Desktop.Window.close_window/2","type":"function"},{"doc":"Fetch the underlying :wxFrame instance object. This represents\nthe window which the webview is drawn into.\n\n  * `pid` - The pid or atom of the Window","ref":"Desktop.Window.html#frame/1","title":"Desktop.Window.frame/1","type":"function"},{"doc":"iex> :wx.set_env(Desktop.Env.wx_env())\n    iex> :wxWindow.show(Desktop.Window.frame(pid), show: false)\n    false","ref":"Desktop.Window.html#frame/1-examples","title":"Examples - Desktop.Window.frame/1","type":"function"},{"doc":"Hide the Window if visible (noop on mobile platforms)\n\n  * `pid` - The pid or atom of the Window","ref":"Desktop.Window.html#hide/1","title":"Desktop.Window.hide/1","type":"function"},{"doc":"iex> Desktop.Window.hide(pid)\n    :ok","ref":"Desktop.Window.html#hide/1-examples","title":"Examples - Desktop.Window.hide/1","type":"function"},{"doc":"Iconize or restore the window\n\n  * `pid` - The pid or atom of the Window\n  * `restore` - Optional defaults to false whether the\n                window should be restored","ref":"Desktop.Window.html#iconize/2","title":"Desktop.Window.iconize/2","type":"function"},{"doc":"Returns true if the window is active. Always returns true\non mobile platforms.\n\n  * `pid` - The pid or atom of the Window","ref":"Desktop.Window.html#is_active?/1","title":"Desktop.Window.is_active?/1","type":"function"},{"doc":"iex> Desktop.Window.is_active?(pid)\n    false","ref":"Desktop.Window.html#is_active?/1-examples","title":"Examples - Desktop.Window.is_active?/1","type":"function"},{"doc":"Returns true if the window is hidden. Always returns false\non mobile platforms.\n\n  * `pid` - The pid or atom of the Window","ref":"Desktop.Window.html#is_hidden?/1","title":"Desktop.Window.is_hidden?/1","type":"function"},{"doc":"iex> Desktop.Window.is_hidden?(pid)\n    false","ref":"Desktop.Window.html#is_hidden?/1-examples","title":"Examples - Desktop.Window.is_hidden?/1","type":"function"},{"doc":"","ref":"Desktop.Window.html#prepare_url/1","title":"Desktop.Window.prepare_url/1","type":"function"},{"doc":"Quit the application. This forces a quick termination which can\nbe helpful on MacOS/Windows as sometimes the destruction is\ncrashing.","ref":"Desktop.Window.html#quit/0","title":"Desktop.Window.quit/0","type":"function"},{"doc":"Rebuild the webview. This function is a troubleshooting\nfunction at this time. On Windows it's sometimes necessary\nto rebuild the WebView2 frame.\n\n  * `pid` - The pid or atom of the Window","ref":"Desktop.Window.html#rebuild_webview/1","title":"Desktop.Window.rebuild_webview/1","type":"function"},{"doc":"iex> Desktop.Window.rebuild_webview(pid)\n    :ok","ref":"Desktop.Window.html#rebuild_webview/1-examples","title":"Examples - Desktop.Window.rebuild_webview/1","type":"function"},{"doc":"Set the windows title\n\n  * `pid` - The pid or atom of the Window\n  * `title` - The new windows title","ref":"Desktop.Window.html#set_title/2","title":"Desktop.Window.set_title/2","type":"function"},{"doc":"iex> Desktop.Window.set_title(pid, \"New Window Title\")\n    :ok","ref":"Desktop.Window.html#set_title/2-examples","title":"Examples - Desktop.Window.set_title/2","type":"function"},{"doc":"Show the Window if not visible with the given url.\n\n  * `pid` - The pid or atom of the Window\n  * `url` - The endpoint url to show. If non is provided\n    the url callback will be used to get one.","ref":"Desktop.Window.html#show/2","title":"Desktop.Window.show/2","type":"function"},{"doc":"iex> Desktop.Window.show(pid, \"/\")\n    :ok","ref":"Desktop.Window.html#show/2-examples","title":"Examples - Desktop.Window.show/2","type":"function"},{"doc":"Show a desktop notification\n\n  * `pid` - The pid or atom of the Window\n\n  * `text` - The text content to show in the notification\n\n  * `opts` - Additional notification options\n\n    Valid keys are:\n\n      * `:id` - An id for the notification, this is important if you\n        want control, the visibility of the notification. The default\n        value when none is provided is `:default`\n\n      * `:type` - One of `:info` `:error` `:warn` these will change\n        how the notification will be displayed. The default is `:info`\n\n      * `:title` - An alternative title for the notificaion,\n        when none is provided the current window title is used.\n\n      * `:timeout` - A timeout hint specifying how long the notification\n        should be displayed.\n\n        Possible values are:\n\n          * `:auto` - This is the default and let's the OS decide\n\n          * `:never` - Indicates that notification should not be hidden\n            automatically\n\n          * ms - A time value in milliseconds, how long the notification\n            should be shown\n\n      * `:callback` - A function to be executed when the user clicks on the\n        notification.","ref":"Desktop.Window.html#show_notification/3","title":"Desktop.Window.show_notification/3","type":"function"},{"doc":"iex> :wx.set_env(Desktop.Env.wx_env())\n    iex> :wxWebView.isContextMenuEnabled(Desktop.Window.webview(pid))\n    false","ref":"Desktop.Window.html#show_notification/3-examples","title":"Examples - Desktop.Window.show_notification/3","type":"function"},{"doc":"Returns the url currently shown of the Window.\n\n  * `pid` - The pid or atom of the Window","ref":"Desktop.Window.html#url/1","title":"Desktop.Window.url/1","type":"function"},{"doc":"iex> Desktop.Window.url(pid)\n    http://localhost:1234/main","ref":"Desktop.Window.html#url/1-examples","title":"Examples - Desktop.Window.url/1","type":"function"},{"doc":"Fetch the underlying :wxWebView instance object. Call\nthis if you have to use more advanced :wxWebView functions\ndirectly on the object.\n\n  * `pid` - The pid or atom of the Window","ref":"Desktop.Window.html#webview/1","title":"Desktop.Window.webview/1","type":"function"},{"doc":"iex> :wx.set_env(Desktop.Env.wx_env())\n    iex> :wxWebView.isContextMenuEnabled(Desktop.Window.webview(pid))\n    false","ref":"Desktop.Window.html#webview/1-examples","title":"Examples - Desktop.Window.webview/1","type":"function"},{"doc":"Elixir version of the constants found in the wx.hrl file, reduced to what is needed in this sample only.","ref":"Desktop.Wx.html","title":"Desktop.Wx","type":"module"},{"doc":"","ref":"Desktop.Wx.html#wxDEFAULT_FRAME_STYLE/0","title":"Desktop.Wx.wxDEFAULT_FRAME_STYLE/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxEXPAND/0","title":"Desktop.Wx.wxEXPAND/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxHORIZONTAL/0","title":"Desktop.Wx.wxHORIZONTAL/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxICON_ERROR/0","title":"Desktop.Wx.wxICON_ERROR/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxICON_INFORMATION/0","title":"Desktop.Wx.wxICON_INFORMATION/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxICON_QUESTION/0","title":"Desktop.Wx.wxICON_QUESTION/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxICON_WARNING/0","title":"Desktop.Wx.wxICON_WARNING/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxID_ANY/0","title":"Desktop.Wx.wxID_ANY/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxID_EXIT/0","title":"Desktop.Wx.wxID_EXIT/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxIMAGE_QUALITY_HIGH/0","title":"Desktop.Wx.wxIMAGE_QUALITY_HIGH/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxITEM_CHECK/0","title":"Desktop.Wx.wxITEM_CHECK/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxITEM_NORMAL/0","title":"Desktop.Wx.wxITEM_NORMAL/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxITEM_RADIO/0","title":"Desktop.Wx.wxITEM_RADIO/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxITEM_SEPARATOR/0","title":"Desktop.Wx.wxITEM_SEPARATOR/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxMAJOR_VERSION/0","title":"Desktop.Wx.wxMAJOR_VERSION/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxMINOR_VERSION/0","title":"Desktop.Wx.wxMINOR_VERSION/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxNO_BORDER/0","title":"Desktop.Wx.wxNO_BORDER/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxRELEASE_NUMBER/0","title":"Desktop.Wx.wxRELEASE_NUMBER/0","type":"function"},{"doc":"","ref":"Desktop.Wx.html#wxVERTICAL/0","title":"Desktop.Wx.wxVERTICAL/0","type":"function"},{"doc":"","ref":"Desktop.Menu.HTMLTokenizer.ParseError.html","title":"Desktop.Menu.HTMLTokenizer.ParseError","type":"exception"},{"doc":"","ref":"Desktop.Menu.HTMLTokenizer.ParseError.html#format_file_line_column/4","title":"Desktop.Menu.HTMLTokenizer.ParseError.format_file_line_column/4","type":"function"},{"doc":"# MIT License\n\nCopyright (c) 2021 Dominic Letz\n\nPermission is hereby granted, free of charge, to any person obtaining\na copy of this software and associated documentation files (the\n\"Software\"), to deal in the Software without restriction, including\nwithout limitation the rights to use, copy, modify, merge, publish,\ndistribute, sublicense, and/or sell copies of the Software, and to\npermit persons to whom the Software is furnished to do so, subject to\nthe following conditions:\n\nThe above copyright notice and this permission notice shall be\nincluded in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\nEXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\nMERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND\nNONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE\nLIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION\nOF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION\nWITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"# Desktop\n\n[![Module Version](https://img.shields.io/hexpm/v/desktop.svg)](https://hex.pm/packages/desktop)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/desktop/)\n[![Total Download](https://img.shields.io/hexpm/dt/desktop.svg)](https://hex.pm/packages/desktop)\n[![License](https://img.shields.io/hexpm/l/desktop.svg)](https://github.com/elixir-desktop/desktop/blob/master/LICENSE.md)\n[![Last Updated](https://img.shields.io/github/last-commit/elixir-desktop/desktop.svg)](https://github.com/elixir-desktop/desktop/commits/master)\n\nBuilding native-like Elixir apps for Windows, MacOS, Linux, iOS and Android using Phoenix LiveView!","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Checkout [the example app](https://github.com/elixir-desktop/desktop-example-app) for a starting point.\n\n![MacOS build](https://raw.githubusercontent.com/elixir-desktop/desktop-example-app/main/nodeploy/macos_todo.png 'MacOS build')","ref":"readme.html#example","title":"Example - Overview","type":"extras"},{"doc":"Check out the [Getting your Environment Ready Guide](./guides/getting_started.md) and [Your first Desktop App](./guides/your_first_desktop_app.md)","ref":"readme.html#getting-started","title":"Getting Started - Overview","type":"extras"},{"doc":"1. ✅ Run elixir-desktop on Windows/MacOS/Linux\n2. ✅ Run elixir-desktop on iOS/Android\n3. ✅ Package elixir-desktop based apps for iOS/Android (see example-app repo for iOS and Android)\n4. Package elixir-desktop based apps in installers for Windows/MacOS/Linux\n5. Update the desktop example app built installers for Windows/MacOS/Linux using GitHub actions\n6. Use a repo of pre-compiled Erlang binaries for Windows/MacOS/Linux/iOS/Android when building Apps, so one call of `mix desktop.deploy` will create installer for all platforms.\n7. Integrate Code Signing for Windows/MacOS\n8. Build a GitHub actions based auto-update flow","ref":"readme.html#status-roadmap","title":"Status / Roadmap - Overview","type":"extras"},{"doc":"- Please checkout [the GitHub repo](https://github.com/elixir-desktop/desktop) and raise any issue.\n- For questions and comments best to use the [Elixir forum](https://elixirforum.com/t/elixir-desktop-android-window-macos-linux-liveview-apps-with-elixir/) or contact me on [Slack](https://elixir-lang.slack.com/archives/C02429KJJCX).\n\nAll suggestions are welcome!\n\nCheers!","ref":"readme.html#contributing-and-raising-issues","title":"Contributing and Raising Issues - Overview","type":"extras"},{"doc":"Copyright (c) 2021 Dominic Letz\n\nThis work is free. You can redistribute it and/or modify it under the terms of the MIT License. See the [LICENSE.md](./LICENSE.md) file for more details.","ref":"readme.html#copyright-and-license","title":"Copyright and License - Overview","type":"extras"},{"doc":"# Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"- Support for iOS hibernation and wakeup","ref":"changelog.html#changes-in-1-5","title":"Changes in 1.5 - Changelog","type":"extras"},{"doc":"- Support for `~H` sigil with ` `\n- Changed Menu XML escaping to LiveView automatic escaping logic from LiveView HTML tokenizer & engine.\n- Removed `Menu.escape_attribute/1` and `Menu.escape/1`\n- Dropped `:xmerl` dependency","ref":"changelog.html#changes-in-1-4","title":"Changes in 1.4 - Changelog","type":"extras"},{"doc":"- Added `Env.subscribe/1` to listen to MacOS application events such as `{:open_url, url}` when a url associated with the application is clicked.\n- Using (experimental) dbus support to render the systray icon on linux\n- Added `Menu.escape_attribute/1`\n- Added `Window.url/1`\n- Added `Window.hide/1` and `Window.is_hidden/`\n- Fixed MacOS \"Quit\" menu item\n- Other fixes","ref":"changelog.html#changes-in-1-3","title":"Changes in 1.3 - Changelog","type":"extras"},{"doc":"- Removed the bleeding edge notices because Erlang OTP 24 is now broadly available for Windows/Linux/MacOS\n- Added build support for iOS devices\n- Moved most phoenix dependencies out to allow using Phoenix 1.6 / esbuild","ref":"changelog.html#changes-in-1-2","title":"Changes in 1.2 - Changelog","type":"extras"},{"doc":"# Getting your Environment Ready","ref":"getting_started.html","title":"Getting your Environment Ready","type":"extras"},{"doc":"Elixir Desktop depends on recent versions of\n\n* Erlang >= OTP/24 (with wxWidgets >= 3.1.15)\n* Elixir >= 1.11.4","ref":"getting_started.html#general-notes","title":"General notes - Getting your Environment Ready","type":"extras"},{"doc":"The setup is using [msys2](https://www.msys2.org/) instead of WSL because we want to produce a native Desktop application that can run on any Windows machine even without WSL installed.\n\n**Install Dependencies:**\n\n* Install Erlang 24: https://erlang.org/downloads\n  * Or Build: https://erlang.org/doc/installation_guide/INSTALL-WIN32.html\n\n* Install msys2 https://www.msys2.org/ \n\nInstall additional msys2 packages from an msys2 64-bit shell\n\n```bash\npacman -Syu\npacman -S --noconfirm pacman-mirrors pkg-config\npacman -S --noconfirm --needed base-devel autoconf automake make libtool mingw-w64-x86_64-toolchain mingw-w64-x86_64-openssl mingw-w64-x86_64-libtool git\n```\n\n**Install Elixir 1.12 (or higher)**\n\nFrom an msys2 64-bit shell do:\n\n```bash\nmkdir $HOME/elixir && cd $HOME/elixir\nwget https://github.com/elixir-lang/elixir/releases/download/v1.12/Precompiled.zip\nunzip Precompiled.zip\necho \"export PATH=\\\"$HOME/elixir/bin:\\$PATH\\\"\" >> ~/.bashrc\nexport PATH=\"$HOME/elixir/bin:$PATH\"\n```\n\n**Install Node**\n\nWe're using esbuild in the new Example app, but you will still need npm at least. \nGet npm & node 12.x (or higher) from https://nodejs.org/dist/latest-v12.x/\n\nThen in msys2 64-bit shell add the nodejs binary path to your `PATH` variable.\n\n**Install dependencies to build an installer**\n\nGet nsis https://nsis.sourceforge.io/Main_Page","ref":"getting_started.html#windows","title":"Windows - Getting your Environment Ready","type":"extras"},{"doc":"Use brew and it will fetch a recent version of Erlang & Elixir:\n\n```bash\nbrew install elixir\n```\n\nFor building NIFs and packaging a release you will also need to get Xcode and install the\nXcode Command Line tools. To install the necessary Xcode tools using Xcode on the Mac:\n\n* Start Xcode on the Mac.\n* Choose Preferences from the Xcode menu.\n* In the General panel, click Downloads.\n* On the Downloads window, choose the Components tab.\n* Click the Install button next to Command Line Tools.\n    - You are asked for your Apple Developer login during the install process. \n\n**Install nodejs / npm 12.16.1**\n\n```bash\nbrew install nvm\nnvm install v12.16.1\n```\n\n**Using custom WxWidgets**\n\nOn macOS good wxWidgets support is pretty recent. You might want to try a newer e.g. master version when you spot visual issues in the native Menus or Taskbar Icon behaviour:\n\n```bash\nmkdir ~/projects && cd ~/projects\ngit clone https://github.com/wxWidgets/wxWidgets.git\ncd wxWidgets\ngit checkout master\n./configure --prefix=/usr/local/wxWidgets --enable-clipboard --enable-controls \\\n      --enable-dataviewctrl --enable-display \\\n      --enable-dnd --enable-graphics_ctx \\\n      --enable-std_string --enable-svg \\\n      --enable-unicode --enable-webview \\\n      --with-expat --with-libjpeg \\\n      --with-libpng --with-libtiff \\\n      --with-opengl --with-zlib \\\n      --disable-precomp-headers --disable-monolithic\n\nmake -j4\n```\n\n**Build Erlang using custom wxWidgets**\n\n```bash\ncurl -O https://raw.githubusercontent.com/kerl/kerl/master/kerl\nchmod a+x kerl\nsudo mv kerl /usr/bin/\nexport LD_LIBRARY_PATH=$HOME/projects/wxWidgets/lib\nexport KERL_CONFIGURE_OPTIONS=--with-wxdir=$HOME/projects/wxWidgets\nkerl build git https://github.com/erlang/otp.git maint-24 maint-24\nkerl install maint-24 ~/maint-24\n. ~/maint-24/activate\n```\n\nIf you're building a custom version of wxWidgets & Erlang you might want to add these to your `.bashrc` or `.zshrc`:\n\n```bash\necho \"export LD_LIBRARY_PATH=\\\"$HOME/projects/wxWidgets/lib\\\"\" >> ~/.bashrc\necho \". ~/maint-24/activate\" >> ~/.bashrc\n\n```","ref":"getting_started.html#macos","title":"MacOS - Getting your Environment Ready","type":"extras"},{"doc":"Best to use Erlang solutions packages: https://www.erlang-solutions.com/downloads/\n\n**Or use ASDF** \n```\nasdf plugin-update --all\nasdf install erlang 24.0.1\n```\n\n**Install NIF Dependencies:**\n\nFor compiling NIFs you will need a c compiler and dependencies, such as from:\n\n```bash\nsudo apt install inotify-tools libtool automake libgmp-dev make libwxgtk-webview3.0-gtk3-dev libssl-dev libncurses5-dev curl git\n```","ref":"getting_started.html#gnu-linux","title":"GNU/Linux - Getting your Environment Ready","type":"extras"},{"doc":"# Your first Desktop App\n\n> If you prefer to start with a working Desktop sample application, please refer to [elixir-desktop/desktop-example-app](https://github.com/elixir-desktop/desktop-example-app).","ref":"your_first_desktop_app.html","title":"Your first Desktop App","type":"extras"},{"doc":"```\n$ mix phx.new demo --no-ecto --no-dashboard --no-mailer\n```\n\nAfter running this command, a demo Phoenix LiveView app will be created:\n\n- OTP app name is `:demo`\n- root module name is `Demo`\n- web root module name is `DemoWeb`","ref":"your_first_desktop_app.html#1-create-a-demo-phoenix-liveview-app","title":"1. Create a demo Phoenix LiveView app - Your first Desktop App","type":"extras"},{"doc":"#","ref":"your_first_desktop_app.html#2-change-above-app-as-a-desktop-app","title":"2. Change above app as a Desktop app - Your first Desktop App","type":"extras"},{"doc":"Add `desktop` package to the dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    # ...\n    {:desktop, github: \"elixir-desktop/desktop\"}\n  ]\nend\n```\n\n#","ref":"your_first_desktop_app.html#2-1-add-required-dependency","title":"2.1 Add required dependency - Your first Desktop App","type":"extras"},{"doc":"```elixir\ndefmodule DemoWeb.Endpoint do\n  # Step 1: Change the endpoint as a `Desktop` endpoint.\n  use Desktop.Endpoint, otp_app: :demo\n\n  # ...\n\n  # Step 2: Add `Desktop.Auth` plug to ensure that only requests from\n  # the Desktop app's WebView are allowed.\n  plug Desktop.Auth\n\n  plug YourAppWeb.Router\nend\n```\n\n#","ref":"your_first_desktop_app.html#2-2-tweak-existing-phoenix-endpoint","title":"2.2 Tweak existing Phoenix endpoint - Your first Desktop App","type":"extras"},{"doc":"```elixir\ndefmodule Demo.Application do\n  # ...\n\n  def start(_type, _args) do\n    children = [\n      # ...\n\n      DemoWeb.Endpoint,\n      {Desktop.Window,\n       [\n         app: :demo,\n         id: DemoWindow,\n         url: &DemoWeb.Endpoint.url/0\n       ]}\n    ]\n\n    # ...\n  end\nend\n```\n\n#","ref":"your_first_desktop_app.html#2-3-add-child-specification-for-opening-webview-window","title":"2.3 Add child specification for opening WebView window - Your first Desktop App","type":"extras"},{"doc":"> You can configure it in `config/dev.exs` or `config/runtime.exs`.\n\n```\nconfig :demo, DemoWeb.Endpoint,\n  # Step 1: set the port number to 0, so the port can be chosen automatically.\n  http: [ip: {127, 0, 0, 1}, port: 0],\n\n  # Step 2: start endpoint automatically, so we have no need to start it manually.\n  server: true,\n  # ...\n```","ref":"your_first_desktop_app.html#2-4-configure-the-desktop-endpoint","title":"2.4 Configure the Desktop endpoint - Your first Desktop App","type":"extras"},{"doc":"#","ref":"your_first_desktop_app.html#3-extra-steps-optional","title":"3. Extra Steps (optional) - Your first Desktop App","type":"extras"},{"doc":"For localization and to autodetect the desktop language, desktop provides a helper function for that. You can call it before starting the app:\n\n```elixir\ndefmodule Demo.Application do\n  # ...\n\n  def start(_type, _args) do\n    Desktop.identify_default_locale(DemoWeb.Gettext)\n\n    children = [\n      # ...\n    ]\n\n    # ...\n  end\nend\n```","ref":"your_first_desktop_app.html#3-1-localization-support","title":"3.1 Localization support - Your first Desktop App","type":"extras"},{"doc":"```\n$ mix run\n```\n\nThe Desktop app should be visible now!","ref":"your_first_desktop_app.html#4-run-it","title":"4. Run it - Your first Desktop App","type":"extras"}]}